;--------------------------------------------------------
; File Created by SDCC : FreeWare ANSI-C Compiler
; Version 2.3.5 Thu Jun 19 11:06:57 2014

;--------------------------------------------------------
	.module minukood
	.optsdcc -mmcs51 --model-small
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _LED
	.globl _LCD_data
	.globl _LCD_instr
	.globl _delay
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
_P0	=	0x0080
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PCON	=	0x0087
_TCON	=	0x0088
_TMOD	=	0x0089
_TL0	=	0x008a
_TL1	=	0x008b
_TH0	=	0x008c
_TH1	=	0x008d
_P1	=	0x0090
_SCON	=	0x0098
_SBUF	=	0x0099
_P2	=	0x00a0
_IE	=	0x00a8
_P3	=	0x00b0
_IP	=	0x00b8
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_T2CON	=	0x00c8
_RCAP2L	=	0x00ca
_RCAP2H	=	0x00cb
_TL2	=	0x00cc
_TH2	=	0x00cd
;--------------------------------------------------------
; special function bits 
;--------------------------------------------------------
_P0_0	=	0x0080
_P0_1	=	0x0081
_P0_2	=	0x0082
_P0_3	=	0x0083
_P0_4	=	0x0084
_P0_5	=	0x0085
_P0_6	=	0x0086
_P0_7	=	0x0087
_IT0	=	0x0088
_IE0	=	0x0089
_IT1	=	0x008a
_IE1	=	0x008b
_TR0	=	0x008c
_TF0	=	0x008d
_TR1	=	0x008e
_TF1	=	0x008f
_P1_0	=	0x0090
_P1_1	=	0x0091
_P1_2	=	0x0092
_P1_3	=	0x0093
_P1_4	=	0x0094
_P1_5	=	0x0095
_P1_6	=	0x0096
_P1_7	=	0x0097
_RI	=	0x0098
_TI	=	0x0099
_RB8	=	0x009a
_TB8	=	0x009b
_REN	=	0x009c
_SM2	=	0x009d
_SM1	=	0x009e
_SM0	=	0x009f
_P2_0	=	0x00a0
_P2_1	=	0x00a1
_P2_2	=	0x00a2
_P2_3	=	0x00a3
_P2_4	=	0x00a4
_P2_5	=	0x00a5
_P2_6	=	0x00a6
_P2_7	=	0x00a7
_EX0	=	0x00a8
_ET0	=	0x00a9
_EX1	=	0x00aa
_ET1	=	0x00ab
_ES	=	0x00ac
_EA	=	0x00af
_P3_0	=	0x00b0
_P3_1	=	0x00b1
_P3_2	=	0x00b2
_P3_3	=	0x00b3
_P3_4	=	0x00b4
_P3_5	=	0x00b5
_P3_6	=	0x00b6
_P3_7	=	0x00b7
_RXD	=	0x00b0
_TXD	=	0x00b1
_INT0	=	0x00b2
_INT1	=	0x00b3
_T0	=	0x00b4
_T1	=	0x00b5
_WR	=	0x00b6
_RD	=	0x00b7
_PX0	=	0x00b8
_PT0	=	0x00b9
_PX1	=	0x00ba
_PT1	=	0x00bb
_PS	=	0x00bc
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
_ET2	=	0x00ad
_T2CON_0	=	0x00c8
_T2CON_1	=	0x00c9
_T2CON_2	=	0x00ca
_T2CON_3	=	0x00cb
_T2CON_4	=	0x00cc
_T2CON_5	=	0x00cd
_T2CON_6	=	0x00ce
_T2CON_7	=	0x00cf
_CP_RL2	=	0x00c8
_C_T2	=	0x00c9
_TR2	=	0x00ca
_EXEN2	=	0x00cb
_TCLK	=	0x00cc
_RCLK	=	0x00cd
_EXF2	=	0x00ce
_TF2	=	0x00cf
;--------------------------------------------------------
; overlayable register banks 
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
	.area	OSEG    (OVR,DATA)
_delay_time_1_1::
	.ds 4
;--------------------------------------------------------
; Stack segment in internal ram 
;--------------------------------------------------------
	.area	SSEG	(DATA)
__start__stack:
	.ds	1

;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_LCD_instr	=	0x8000
_LCD_data	=	0x8001
_LED	=	0xa000
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
;--------------------------------------------------------
; interrupt vector 
;--------------------------------------------------------
	.area CSEG    (CODE)
__interrupt_vect:
	ljmp	__sdcc_gsinit_startup
	reti
	.ds	7
	reti
	.ds	7
	reti
	.ds	7
	reti
	.ds	7
	reti
	.ds	7
	reti
	.ds	7
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
__sdcc_gsinit_startup:
	mov	sp,#__start__stack - 1
	lcall	__sdcc_external_startup
	mov	a,dpl
	jz	__sdcc_init_data
	ljmp	__sdcc_program_startup
__sdcc_init_data:
;	_mcs51_genXINIT() start
	mov	a,#l_XINIT
	orl	a,#l_XINIT>>8
	jz	00003$
	mov	a,#s_XINIT
	add	a,#l_XINIT
	mov	r1,a
	mov	a,#s_XINIT>>8
	addc	a,#l_XINIT>>8
	mov	r2,a
	mov	dptr,#s_XINIT
	mov	r0,#s_XISEG
	mov	p2,#(s_XISEG >> 8)
00001$:	clr	a
	movc	a,@a+dptr
	movx	@r0,a
	inc	dptr
	inc	r0
	cjne	r0,#0,00002$
	inc	p2
00002$:	mov	a,dpl
	cjne	a,ar1,00001$
	mov	a,dph
	cjne	a,ar2,00001$
	mov	p2,#0xFF
00003$:
;	_mcs51_genXINIT() end
	.area GSFINAL (CODE)
	ljmp	__sdcc_program_startup
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
__sdcc_program_startup:
	lcall	_main
;	return from main will lock up
	sjmp .
;------------------------------------------------------------
;Allocation info for local variables in function 'main'
;------------------------------------------------------------
;i                         Allocated to registers 
;------------------------------------------------------------
;minukood.c:13: int main() {
;	-----------------------------------------
;	 function main
;	-----------------------------------------
_main:
	ar2 = 0x02
	ar3 = 0x03
	ar4 = 0x04
	ar5 = 0x05
	ar6 = 0x06
	ar7 = 0x07
	ar0 = 0x00
	ar1 = 0x01
;minukood.c:16: LCD_instr=0x0100;
;     genAssign
	mov	dptr,#_LCD_instr
;       Peephole 181    changed mov to clr
	clr     a
	movx	@dptr,a
	inc	dptr
	mov	a,#0x01
	movx	@dptr,a
;minukood.c:17: LED=0x0000;
;     genAssign
;       Peephole 229    replaced inefficient 16 bit clear
	mov     dptr,#_LED
	clr     a
	movx    @dptr,a
	inc     dptr
	movx    @dptr,a
;minukood.c:18: delay(500);
;     genCall
;       Peephole 182.b  used 16 bit load of dptr
;       Peephole 231    removed redundant mov to dptr
	mov     dptr,#0x01F4
;       Peephole 3.a    changed mov to clr
	clr     a
	mov     b,a
	lcall	_delay
;minukood.c:22: delay(500);
;     genCall
;       Peephole 182.b  used 16 bit load of dptr
	mov     dptr,#0x01F4
;       Peephole 3.a    changed mov to clr
	clr     a
	mov     b,a
	lcall	_delay
;minukood.c:32: while (i<255)
00110$:
;     genAssign
	mov	r2,#0x00
	mov	r3,#0x00
00101$:
;     genCmpLt
;     genCmp
	clr	c
	mov	a,r2
	subb	a,#0xFF
	mov	a,r3
	xrl	a,#0x80
	subb	a,#0x80
;     genIfx
;     genIfxJump
;       Peephole 110    removed ljmp by inverse jump logic
;       Peephole 128    jump optimization
	jnc     00103$
00112$:
;minukood.c:34: i++;
;     genPlus
;     genPlusIncr
	inc	r2
	cjne	r2,#0x00,00113$
	inc	r3
00113$:
;minukood.c:35: delay(1);
;     genCall
	mov	dpl,#0x01
;       Peephole 3.a    changed mov to clr
;       Peephole 3.b    changed mov to clr
	clr     a
	mov     dph,a
	mov     b,a
	push	ar2
	push	ar3
	lcall	_delay
	pop	ar3
	pop	ar2
;       Peephole 132    changed ljmp to sjmp
	sjmp    00101$
00103$:
;minukood.c:37: LED=0xAA00; //Vasakud bitid on LEDid, paremad pole.
;     genAssign
	mov	dptr,#_LED
;       Peephole 181    changed mov to clr
	clr     a
	movx	@dptr,a
	inc	dptr
	mov	a,#0xAA
	movx	@dptr,a
;minukood.c:40: return 0;
;       Peephole 132    changed ljmp to sjmp
	sjmp    00110$
00107$:
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'delay'
;------------------------------------------------------------
;------------------------------------------------------------
;minukood.c:45: void delay(long time){
;	-----------------------------------------
;	 function delay
;	-----------------------------------------
_delay:
;     genReceive
	mov	r2,dpl
	mov	r3,dph
	mov	r4,b
	mov	r5,a
;minukood.c:47: for(i=0;i<time;i++)for(j=0;j<255;j++);
;     genAssign
	mov	_delay_time_1_1,r2
	mov	(_delay_time_1_1 + 1),r3
	mov	(_delay_time_1_1 + 2),r4
	mov	(_delay_time_1_1 + 3),r5
;     genAssign
	mov	r6,#0x00
	mov	r7,#0x00
00104$:
;     genCast
	mov	ar0,r6
	mov	ar1,r7
	mov	r2,#0x00
	mov	r3,#0x00
;     genCmpLt
;     genCmp
	clr	c
	mov	a,r0
	subb	a,_delay_time_1_1
	mov	a,r1
	subb	a,(_delay_time_1_1 + 1)
	mov	a,r2
	subb	a,(_delay_time_1_1 + 2)
	mov	a,r3
	subb	a,(_delay_time_1_1 + 3)
;     genIfxJump
;       Peephole 108    removed ljmp by inverse jump logic
	jnc     00108$
00114$:
;     genAssign
	mov	r2,#0xFF
	mov	r3,#0x00
00103$:
;     genDjnz
;     genMinus
;     genMinusDec
	dec	r2
	cjne	r2,#0xff,00115$
	dec	r3
00115$:
;     genIfx
	mov	a,r2
	orl	a,r3
;     genIfxJump
;       Peephole 109    removed ljmp by inverse jump logic
	jnz     00103$
00116$:
;     genPlus
;     genPlusIncr
;	tail increment optimized
	inc	r6
	cjne	r6,#0x00,00104$
	inc	r7
;       Peephole 132    changed ljmp to sjmp
	sjmp    00104$
00108$:
	ret
	.area CSEG    (CODE)
	.area XINIT   (CODE)
